/**
 * Object to check for avaliable updates and show a flyout
 */
var Update = new function(){
	
	this.url='http://www.vitim.tk/gadgets/ibattery/update.html';
	this.data='';
	var that=this;
	
	/**	Method check for new version */
	this.check=function(){
		
		var request = new ClassAjax();
		request.onCompleted=that.completed;
		request.get(that.url,null);
		
	}
	
	/** Event called when data is retrived from server */
	this.completed=function(data){
		that.data=data;
		
		var gadgetname=System.Gadget.name;
		var gadgetversion=System.Gadget.version;
		var remotename=readTag(data,'ProductName')[0];
		var remoteversion=readTag(data,'LastVersion')[0];
		
		if ( remotename == gadgetname ){

			if( compareVersion(gadgetversion,remoteversion)==true ){ //if remote version is bigger then actual 
				//New version avaliable
				that.updateAvaliable();
			}else {
				//Already updated
			}
			
		}else{
			//Not found			
		}
	}
	
	
	this.updateAvaliable=function(){
		
		var data=that.data;
		
		System.Gadget.Flyout.file = "Views/Flyout/Update.html"; //Flyout update file
		System.Gadget.Flyout.show = true;
		
		var Flyout=System.Gadget.Flyout.document.parentWindow;
		
		Flyout.version=readTag(data,'LastVersion')[0];
		Flyout.released=readTag(data,'ReleaseDate')[0];
		Flyout.current=System.Gadget.version;
		Flyout.site=readTag(data,'ProductLink')[0];
		
		Array.prototype.randomItem =  function(){
		    return this[Math.floor(Math.random()*this.length)];
		};
		
		Flyout.download=readTag(data,'Mirror').randomItem();
		
		updatebutton(); //create a button on gadget
			
	}
	
	
	function readTag(str,property){
	
		var beginTag='['+property+']';
		var endTag='[/'+property+']';
		
		var values=new Array(0);
		
		while(str.indexOf(beginTag)!=-1){
			values[values.length]=strBetween(str,beginTag,endTag);
			str=str.substring(str.indexOf(endTag)+endTag.length);
		}
		return(values);
	}
	
	function strBetween(string,strBegin,strEnd){	//StrBetween("abcdef","b","e")  //return "cd"
	
		var posBegin, posEnd;
	
		posBegin=string.indexOf(strBegin);	//encontra o inicio da substring
		string=string.substring(posBegin + strBegin.length); //apaga tudo antes do strBegin
		posEnd=string.indexOf(strEnd);	//encontra o final da substring
		string=string.substring(0,posEnd); //apaga tudo depois do strEnd
			
		if ((posBegin==-1)||(posEnd==-1)){ //if strBegin or strEnd, not found return Null
			return(null);
		}else{
			return(string);
		}
	}
	
	/** Compare two versions and return true if newVersion is bigger then current */
	function compareVersion(curVersion,newVersion){
		
		var result=false;
		
		if(typeof curVersion!=='object'){ curVersion=curVersion.toString().split('.'); }
		if(typeof newVersion!=='object'){ newVersion=newVersion.toString().split('.'); }
		
		for(var i=0;i<(Math.max(curVersion.length,newVersion.length));i++){
			
			if(curVersion[i]==undefined){ curVersion[i]=0; }
			if(newVersion[i]==undefined){ newVersion[i]=0; }
			
			if(curVersion[i]<newVersion[i]){
				result=true;
				break;
			}
			if(curVersion[i]>newVersion[i]){
				break;
			}
		}
		return(result);
	}	

}




/**
 * Class to make standard Ajax XML Http Request
 */
var ClassAjax=function(){

	this.preventCache=true;
	
	this.data=null;

	var that=this;
	this.get=function(url,send){
				
		var ajax = new function ObjAjax(){
			try{return new XMLHttpRequest()}
			catch(e){try{return new ActiveXObject("Msxml2.XMLHTTP")}
			catch(e){return new ActiveXObject("Microsoft.XMLHTTP")}}
			return null;
		}
		
		ajax.onreadystatechange = function(){
			if(ajax.readyState == 1){that.onLoading();}
			if(ajax.readyState == 4){that.data=ajax.responseText; that.onCompleted(that.data);}	
		}
		
		function timestamp(enabled){
			if(enabled){
				if(url.indexOf('?')==-1){ var ts='?'; }
				else{ var ts='&'; }
				ts+='ts='+new Date().getTime();
				return(ts);
			}else{
				return('');
			}
		}
		
		ajax.open("GET",url+timestamp(that.preventCache),true);
		ajax.send(send);

	};
	
	this.onLoading=function(){
		//function called when connection was opened
	};
	
	this.onCompleted=function(data){
		//function called when download was completed
	};
}




function updatebutton(){
		
	var text="Click";
	var id="updatebtn";
	
	var css="position:absolute; z-index:1; width:80px; height:32px; left:50%; top:50%; margin-left:-40px; margin-top:-16px;";
	var action=function(){ Update.updateAvaliable(); }
	var mybutton=creatButton(id,text,css,action); //Create the button
	document.body.appendChild(mybutton); //Add the button to the end of <body>


	function creatButton(id,text,style,action){
	
		if(document.getElementById(id)===null){	
			
			var btn;
			btn=document.createElement('button')
			btn.setAttribute('id',id);
			btn.appendChild(document.createTextNode(text));
			btn.style.cssText=style;
			btn.onclick=action;
			return(btn);
			
		}else{
			return(document.getElementById(id));	
		}
	}

}
