/*
 * @author Vitim
 */

var ViewController=new function(){

	/* Public Properties */
	this.ShowPercent=true;
	this.ShowTime=true;
	this.ShowStatusIcon=true;
	
	/* Private */
	var SkinName="Default"; //dont modify, use SetSkin method
	var SkinFolder;
	
	//Visual Components
	var background;
	var ImageBattery;
	var ImageStatus;
	var TextPercent;
	var TextTime;
	
	var parent=this;
	
	//Methods
	this.Create=function(){
		
		background=document.getElementById("imgBackground");
		
		ImageBattery = background.addImageObject("", 0, 0);
		ImageStatus = background.addImageObject("", 80, 20);
		TextPercent = background.addTextObject(" ", "Segoe UI", 20, "White", 45, 23);
		TextTime = background.addTextObject(" ", "Segoe UI", 9, "White", 38, 50);
		
		TextPercent.width = 60;
   		TextPercent.align = 1;
		
		TextTime.width = 60;
		TextTime.align = 1;
		
		//ImageBattery.width = 130;
		//ImageBattery.height = 56;
			
	}
	
	this.Destroy=function(){
		
		background.removeObjects();
		
	}
	
	
	this.SetSkin=function(Name){
		
		SkinName=Name;
		SkinFolder="..\\..\\Resources\\images\\"+SkinName+"\\";
		
		//make Changes / force update	
	}
	
	
	this.Level=function(percent){ //This method change BatteryImage and TextPercent to respective percent
		
		if(percent<0){percent=0;}		//fix for negative values	(show empty battery and 0%)
		if(percent===null){percent=0;}	//fix for null value		(show empty battery and 0%)
		
		
		if(percent>=0 && percent<=100){	//Values between 0% ~ 100%
			changeTextPercent(percent,this.ShowPercent);
			changeBatteryImage(percent);
		}
		else if(percent==255 || percent>100){ //NO BATTERY
			changeTextPercent(' ',false);
			changeBatteryImage(null);
		}
	}
	
	
	this.Status=function(PowerCord,Charging){
		if(this.ShowStatusIcon){
			
			if(Charging){ // Tomada, Carregando
			
				ImageStatus.src=SkinFolder+"status_charging.png";
				//"Plugged-in, Charging battery...";
			}	
			else if(PowerCord){ // Tomada, Nao carregando
				
				ImageStatus.src=SkinFolder+"status_ac.png";
				//"Plugged-in, Not charging.";
			}	
			else { // Bateria, descarregando
				
				ImageStatus.src=SkinFolder+"status_discharging.png";
				//"Powered by battery only.";
			}	
			
		}else{
			ImageStatus.src=SkinFolder+"status_hide.png";
		}
	}
	
	
	this.Time=function(remaingTime,show){
		
		if(this.ShowTime && show){
			
				TextTime.value=secondsToHMS(remaingTime);
				//TextTime.value=remaingTime;
		}else{
			TextTime.value=" ";
		}
		
		function secondsToHMS(seconds) {
			
			var d = Number(seconds);
			var h = Math.floor(d / 3600);
			var m = Math.floor(d % 3600 / 60);
			var s = Math.floor(d % 3600 % 60);
			
			if(s>30){m=m+1;} //round seconds to minutes
			
			if(h>0){ h=h+':'; }else{ h='00:'; }
			if(m<10){ m='0'+m }else{m=m};
			if(s<10){ s='0'+s; }else{s=s;}
			
			
			
			var timeString= h+m;
			
			return( timeString );
		}
	}
	
	function changeBatteryImage(percent){ //Internal Function (select each image for respective percent)
		
		var ImageName;
		
		if(percent===null){
			ImageName="nobat"; //No Battery
		}
		else if(percent>=0 || percent<=100){
				 if (percent<=100 && percent>=90) { ImageName = "8"; }
			else if (percent<90 && percent>=80) { ImageName = "7"; }
			else if (percent<80 && percent>=70) { ImageName = "6"; }
			else if (percent<70 && percent>=60) { ImageName = "5"; }
			else if (percent<60 && percent>=50) { ImageName = "4"; } 
			else if (percent<50 && percent>=30) { ImageName = "3"; } 
			else if (percent<30 && percent>=10) { ImageName = "2"; } 
			else if (percent<10 && percent>=7) { ImageName = "1"; } 
			else if (percent<7 && percent>=0 ) { ImageName = "0"; }
			
		}
				
		ImageBattery.src = SkinFolder +ImageName+ ".png";		
	}
	
	function changeTextPercent(percent,show){
				
		if(show) {
			TextPercent.value = percent + "%";
		}else{
			TextPercent.value = " ";
		}
	}	
}