/******************************** Standard Gadget Code ***********************/

function Init(){
	
	//* Enable the gadget Settings functionality. 
	System.Gadget.settingsUI = "Views/Settings/Settings.html";
	
	//* Delegate for when the Settings dialog is closed.
	System.Gadget.onSettingsClosed = settingsWasClosed;
	
	//* Delegate for when the Settings dialog is instantiated.
	System.Gadget.onShowSettings = settingsWasOpened;
	
	//* Delegate for when Dock and Undock changes
	//System.Gadget.onDock = wasDocked;			//not used in this project
	//System.Gadget.onUndock = wasUndocked;		//not used in this project
	
	//* Specify the Flyout root.
	//System.Gadget.Flyout.file = "Views/Flyout/Flyout.html";
	
	
	
	start();

	
}


function wasDocked(){
	System.Gadget.beginTransition();
	
	document.body.style.width=130+"px";
	document.getElementById("imgBackground").src = "url(../../Resources/images/bg_docked.png)";
	document.getElementById("imgBackground").style.width = "130px";
	
	System.Gadget.endTransition(System.Gadget.TransitionType.none, 0);
}

function wasUndocked(){
	System.Gadget.beginTransition();
	
	document.body.style.width=200+"px";
	document.getElementById("imgBackground").src = "url(../../Resources/images/bg_undocked.png)";
	document.getElementById("imgBackground").style.width = "200px";
	System.Gadget.endTransition(System.Gadget.TransitionType.none, 0);
}

function settingsWasClosed(event)
{
	// User hit OK on the settings page.
	if (event.closeAction == event.Action.commit){
		
		start();
		
	}
	// User hit Cancel on the settings page.
	else if (event.closeAction == event.Action.cancel){
		
		start();
		
	}
}

function settingsWasOpened(){
    // User opened the configuration page
	
	pause();

}


var oFlyoutDocument;

function showFlyout(){
    System.Gadget.Flyout.show = true;
    oFlyoutDocument = System.Gadget.Flyout.document;
}

function hideFlyout(){
    System.Gadget.Flyout.show = false;
}

/*****************************************************************************/

//Implementation


function start(){
	
	//Read this properties from settings...

	ViewController.SetSkin( readSettings('skinTheme', 'Green') );	
	ViewController.ShowPercent = returnBoolean( readSettings('showPercent', 'true'));
	ViewController.ShowTime = returnBoolean( readSettings('showTime', 'false'));
	ViewController.ShowStatusIcon = returnBoolean( readSettings('showStatus', 'true'));
	
	Sound.enabled = returnBoolean( readSettings('enableSound', 'true'));
	Sound.SetTheme( readSettings('soundTheme', 'iPhone') );
	
	ViewController.Create();
	Battery.Create();
	
}


function pause(){
	
	ViewController.Destroy();
	Battery.Destroy();
	
}



/** 
 * Retrieves a stored String value associated with a gadget Settings key. (Sidebar API)
 * @param {String}	key			String that specifies or receives the name of the Settings key. (limit of 1024 character)
 * @param {String}	defaultValue	If the key is empty or not exist, return this value.
 * @return {String}	The String value of the Settings key.
 */
function readSettings(key, defaultValue){
    var value = System.Gadget.Settings.read(key);
    if (value === '' || value === undefined) {
        value = defaultValue;
    }
    return (value);
}


/** 
 * Stores a String value with an associated Settings key. (Sidebar API).
 * @param {String}	key		String that specifies the name of the Settings key. (limit of 1024 character)
 * @param {String}	value	The String value to store. (limit of 2048 character)
 * @param {Bool}	check	Check if value was stored right (False to skip check, and always return True).
 * @return {Bool}		Return true when check was successfull. (param check=false always return true).
 */
function writeSettings(key, value, check){
	
	System.Gadget.Settings.write(key,value);
    
	var success=true;
	
	if(check===true){
		var readedValue=System.Gadget.Settings.read(key);
		success = (value===readedValue);
	}
	
	return(success);
}

function returnBoolean(str){
	
	str=str.toString().toLowerCase();

	if(str=='true' || str=='1' || str=='yes' || str=='y' || str=='on' || str=='+'){
		return(true);
	}
	else if(str=='false' || str=='0' || str=='no' || str=='n' || str=='off' || str=='-'){
		return(false);
	}else{
		return(undefined);
	}
}